diff -r -c ../ingres.ptf/source/parser/grammar.y source/parser/grammar.y
*** ../ingres.ptf/source/parser/grammar.y	Mon Nov 16 14:38:59 1992
--- source/parser/grammar.y	Mon Sep 14 18:30:58 1992
***************
*** 27,33 ****
  SCCSID(@(#)grammar.y	8.6	5/30/88)
  
  # ifdef		xPTR1
! # define	YYDEBUG
  # endif
  
  int				i;
--- 27,33 ----
  SCCSID(@(#)grammar.y	8.6	5/30/88)
  
  # ifdef		xPTR1
! # define	YYDEBUG	1
  # endif
  
  int				i;
***************
*** 50,55 ****
--- 50,56 ----
  extern struct atstash 		Faketid;
  extern char			*Tuple;
  extern TID			tid;
+ extern int                      Err_current;
  
  # ifdef	DISTRIB
  extern struct atstash		Fakesid;
Only in source/parser: grammar.z
diff -r -c ../ingres.ptf/source/parser/par_init.c source/parser/par_init.c
*** ../ingres.ptf/source/parser/par_init.c	Mon Nov 16 14:38:57 1992
--- source/parser/par_init.c	Tue Sep 15 12:15:42 1992
***************
*** 13,18 ****
--- 13,19 ----
  **		par_init ~~ 60.0
  */
  
+ void
  par_init(argc, argv1)
  int	argc;
  char	*argv1[];
diff -r -c ../ingres.ptf/source/parser/parser.c source/parser/parser.c
*** ../ingres.ptf/source/parser/parser.c	Mon Nov 16 14:38:57 1992
--- source/parser/parser.c	Tue Sep 15 12:15:43 1992
***************
*** 13,19 ****
  short			tTparser[100];
  
  extern int		parser();
! extern int		par_init();
  
  struct fn_def		ParserFn =
  			{
--- 13,19 ----
  short			tTparser[100];
  
  extern int		parser();
! extern void		par_init();
  
  struct fn_def		ParserFn =
  			{
diff -r -c ../ingres.ptf/source/parser/tree.c source/parser/tree.c
*** ../ingres.ptf/source/parser/tree.c	Mon Nov 16 14:38:58 1992
--- source/parser/tree.c	Thu Sep 10 19:37:29 1992
***************
*** 754,759 ****
--- 754,760 ----
  */
  predef_delims()
  {
+ 	extern DELIMLIST	*Delimhead;
  	DELIMLIST	*d;
  	DMAP		*m, *m2;
  	int		i;
diff -r -c ../ingres.ptf/source/qrymod/d_integ.c source/qrymod/d_integ.c
*** ../ingres.ptf/source/qrymod/d_integ.c	Mon Nov 16 14:39:03 1992
--- source/qrymod/d_integ.c	Tue Jun  9 14:14:09 1992
***************
*** 35,41 ****
  extern DESC	Intdes;
  extern DESC	Reldes;
  
! extern		d_integ(), null_fn();
  extern short	tTqm[80];
  
  struct fn_def	DefIntFn =
--- 35,42 ----
  extern DESC	Intdes;
  extern DESC	Reldes;
  
! extern	void	 null_fn();
! extern          d_integ();
  extern short	tTqm[80];
  
  struct fn_def	DefIntFn =
diff -r -c ../ingres.ptf/source/qrymod/d_prot.c source/qrymod/d_prot.c
*** ../ingres.ptf/source/qrymod/d_prot.c	Mon Nov 16 14:39:04 1992
--- source/qrymod/d_prot.c	Tue Sep 15 12:15:41 1992
***************
*** 73,79 ****
  extern DESC		Prodes;
  extern DESC		Reldes;
  
! extern		d_prot(), null_fn();
  extern short	tTqm[80];
  
  struct fn_def	DefProFn =
--- 73,80 ----
  extern DESC		Prodes;
  extern DESC		Reldes;
  
! extern	void	null_fn();
! extern          d_prot();
  extern short	tTqm[80];
  
  struct fn_def	DefProFn =
diff -r -c ../ingres.ptf/source/qrymod/d_view.c source/qrymod/d_view.c
*** ../ingres.ptf/source/qrymod/d_view.c	Mon Nov 16 14:39:03 1992
--- source/qrymod/d_view.c	Tue Jun  9 14:14:08 1992
***************
*** 42,48 ****
  
  extern DESC	Reldes;
  
! extern		d_view(), null_fn();
  extern short	tTqm[80];
  
  struct fn_def	DefViewFn =
--- 42,49 ----
  
  extern DESC	Reldes;
  
! extern	void	null_fn();
! extern          d_view();
  extern short	tTqm[80];
  
  struct fn_def	DefViewFn =
diff -r -c ../ingres.ptf/source/qrymod/qrymod.c source/qrymod/qrymod.c
*** ../ingres.ptf/source/qrymod/qrymod.c	Mon Nov 16 14:39:04 1992
--- source/qrymod/qrymod.c	Fri Sep 25 15:35:17 1992
***************
*** 33,39 ****
  
  # define TTYIDSIZE	8	/* length of tty id */
  
! extern	qrymod(), qm_init(), null_fn();
  short	tTqm[80];
  char	Terminal[TTYIDSIZE + 1];
  
--- 33,40 ----
  
  # define TTYIDSIZE	8	/* length of tty id */
  
! extern	qrymod();
! extern  void     qm_init(), null_fn();
  short	tTqm[80];
  char	Terminal[TTYIDSIZE + 1];
  
***************
*** 52,58 ****
  };
  
  
! 
  qm_init(argc, argv)
  int	argc;
  char	**argv;
--- 53,59 ----
  };
  
  
! void
  qm_init(argc, argv)
  int	argc;
  char	**argv;
***************
*** 103,109 ****
  **		none.
  */
  
! 
  qrymod(pc, pv)
  int	pc;
  PARM	*pv;
--- 104,110 ----
  **		none.
  */
  
! int
  qrymod(pc, pv)
  int	pc;
  PARM	*pv;
diff -r -c ../ingres.ptf/source/support/Makefile source/support/Makefile
*** ../ingres.ptf/source/support/Makefile	Mon Nov 16 14:39:00 1992
--- source/support/Makefile	Wed Oct 21 16:37:48 1992
***************
*** 8,14 ****
  H=	../h
  LIB=	$(INGRES)/lib
  BIN=	$(INGRES)/bin
! SYSBIN=	/usr/local
  
  ALL=	creatdb destroydb helpr printr purge \
  	restore usersetup ingres printadmin \
--- 8,14 ----
  H=	../h
  LIB=	$(INGRES)/lib
  BIN=	$(INGRES)/bin
! SYSBIN=	/usr/local/bin
  
  ALL=	creatdb destroydb helpr printr purge \
  	restore usersetup ingres printadmin \
***************
*** 16,22 ****
  SRCS=	creatdb.c destroydb.c error.c helpr.c ingres.y \
  	printr.c purge.c subs.c usersetup.c \
  	restore.c copydb.q prvect.c printadmin.c \
! 	demodb.sh initsocket.c ildr.c ingconv.q 
  HDRS=	ildr.h
  
  CTLMOD=	$(LIB)/ctlmod
--- 16,22 ----
  SRCS=	creatdb.c destroydb.c error.c helpr.c ingres.y \
  	printr.c purge.c subs.c usersetup.c \
  	restore.c copydb.q prvect.c printadmin.c \
! 	demodb.sh initsocket.c ildr.c ingconv.q
  HDRS=	ildr.h
  
  CTLMOD=	$(LIB)/ctlmod
***************
*** 25,34 ****
  DBULIB=	$(LIB)/dbulib
  LIBS1=	$(GUTIL)
  LIBS2=	$(IUTIL) $(GUTIL)
! LIBS4=	$(DBULIB) $(IUTIL) $(GUTIL) $(CTLMOD)
! LIBS4=  externs.o $(DBULIB) $(IUTIL) $(CTLMOD) $(GUTIL) $(IUTIL)
  
! CFLAGS=	-O -I$H -I../ctlmod
  EQUEL=	$(BIN)/equel
  LDFLAGS=
  CP=	cp
--- 25,33 ----
  DBULIB=	$(LIB)/dbulib
  LIBS1=	$(GUTIL)
  LIBS2=	$(IUTIL) $(GUTIL)
! LIBS3=  externs.o $(DBULIB) $(IUTIL) $(CTLMOD) $(GUTIL)
  
! CFLAGS=	-O -I$H -I../ctlmod #-DDEBUG
  EQUEL=	$(BIN)/equel
  LDFLAGS=
  CP=	cp
***************
*** 65,82 ****
  	$(CHMOD) $(SUMODE) ingconv
  	ls -l ingconv; size ingconv
  
! creatdb: creatdb.o error.o prvect.o $(LIBS4)
! 	$(CC) $(LDFLAGS) creatdb.o error.o prvect.o $(LIBS4) -lm -o creatdb
  	$(CHMOD) $(SUMODE) creatdb
  	ls -l creatdb; size creatdb
  
! destroydb: destroydb.o $(LIBS4)
! 	$(CC) $(LDFLAGS) destroydb.o $(LIBS4) -lm -o destroydb
  	$(CHMOD) $(SUMODE) destroydb
  	ls -l destroydb; size destroydb
  
! helpr:	helpr.o error.o prvect.o $(LIBS4) 
! 	$(CC) $(LDFLAGS) helpr.o error.o prvect.o $(LIBS4) -lm -o helpr
  	$(CHMOD) $(SUMODE) helpr
  	ls -l helpr; size helpr
  
--- 64,81 ----
  	$(CHMOD) $(SUMODE) ingconv
  	ls -l ingconv; size ingconv
  
! creatdb: creatdb.o error.o prvect.o $(LIBS3)
! 	$(CC) $(LDFLAGS) creatdb.o error.o prvect.o $(LIBS3) ../iutil/closecat.o -lm -o creatdb
  	$(CHMOD) $(SUMODE) creatdb
  	ls -l creatdb; size creatdb
  
! destroydb: destroydb.o $(LIBS3)
! 	$(CC) $(LDFLAGS) destroydb.o $(LIBS3) ../iutil/closecat.o -lm -o destroydb
  	$(CHMOD) $(SUMODE) destroydb
  	ls -l destroydb; size destroydb
  
! helpr:	helpr.o error.o prvect.o $(LIBS3)
! 	$(CC) $(LDFLAGS) helpr.o error.o prvect.o $(LIBS3) ../iutil/closecat.o -lm -o helpr
  	$(CHMOD) $(SUMODE) helpr
  	ls -l helpr; size helpr
  
***************
*** 94,100 ****
  	$(CC) $(CFLAGS) -I../ctlmod -c ingres.c
  
  ingreslock: ildr.o initsocket.o
! 	$(CC) $(CFLAGS) -o ingreslock ildr.o initsocket.o 
  	$(CHMOD) $(BINMODE) ingreslock
  	ls -l ingreslock ; size ingreslock
  
--- 93,99 ----
  	$(CC) $(CFLAGS) -I../ctlmod -c ingres.c
  
  ingreslock: ildr.o initsocket.o
! 	$(CC) $(CFLAGS) -o ingreslock ildr.o initsocket.o
  	$(CHMOD) $(BINMODE) ingreslock
  	ls -l ingreslock ; size ingreslock
  
***************
*** 103,120 ****
  	$(CHMOD) $(SUMODE) printadmin
  	ls -l printadmin; size printadmin
  
! printr: printr.o error.o prvect.o $(LIBS4)
! 	$(CC) $(LDFLAGS) printr.o error.o prvect.o $(LIBS4) -lm -o printr
  	$(CHMOD) $(SUMODE) printr
  	ls -l printr; size printr
  
! purge: purge.o subs.o error.o $(LIBS4)
! 	$(CC) $(LDFLAGS) purge.o subs.o error.o $(LIBS4) -lm  -o purge
  	$(CHMOD) $(SUMODE) purge
  	ls -l purge; size purge
  
! restore: restore.o subs.o error.o $(LIBS4)
! 	$(CC) $(LDFLAGS) restore.o subs.o error.o $(LIBS4) -lm -o restore
  	$(CHMOD) $(SUMODE) restore
  	ls -l restore; size restore
  
--- 102,119 ----
  	$(CHMOD) $(SUMODE) printadmin
  	ls -l printadmin; size printadmin
  
! printr: printr.o error.o prvect.o $(LIBS3)
! 	$(CC) $(LDFLAGS) printr.o error.o prvect.o $(LIBS3) ../iutil/closecat.o -lm -o printr
  	$(CHMOD) $(SUMODE) printr
  	ls -l printr; size printr
  
! purge: purge.o subs.o error.o $(LIBS3)
! 	$(CC) $(LDFLAGS) purge.o subs.o error.o $(LIBS3) -lm  -o purge
  	$(CHMOD) $(SUMODE) purge
  	ls -l purge; size purge
  
! restore: restore.o subs.o error.o $(LIBS3)
! 	$(CC) $(LDFLAGS) restore.o subs.o error.o $(LIBS3) -lm -o restore
  	$(CHMOD) $(SUMODE) restore
  	ls -l restore; size restore
  
diff -r -c ../ingres.ptf/source/support/copydb.q source/support/copydb.q
*** ../ingres.ptf/source/support/copydb.q	Mon Nov 16 14:39:01 1992
--- source/support/copydb.q	Wed Sep 30 14:35:19 1992
***************
*** 13,23 ****
  # define	INT	30
  # define	FLOAT	31
  # define	CHAR	32
! ##char	Usercode[100];
  char	**Wanted;
  int	Status;
  
! extern	int	(*ExitFn)();
  FILE	*Ifile, *Ofile;
  
  struct relation
--- 13,23 ----
  # define	INT	30
  # define	FLOAT	31
  # define	CHAR	32
! ##  char	Usercode[100];
  char	**Wanted;
  int	Status;
  
! extern	void	(*ExitFn)();
  FILE	*Ifile, *Ofile;
  
  struct relation
***************
*** 48,53 ****
--- 48,54 ----
  **	The function to call for an exit to occur, this
  **	is all for the benefit of syserr, so it doesn't core dump.
  */
+ void
  sysexit(value)
  int	value;
  {
***************
*** 100,108 ****
  		printf("Warning %s is not a full path name\n",path);
  
  
! 	if ((Ifile = fopen(ztack(path,"/copy.in"), "w")) == NULL)
  		syserr(0,"Cannot create %s!",ztack(path,"/copy.in"));
! 	if ((Ofile = fopen(ztack(path,"/copy.out"), "w")) == NULL)
  		syserr(0,"Cannot create %s!",ztack(path,"/copy.out"));
  
  
--- 101,109 ----
  		printf("Warning %s is not a full path name\n",path);
  
  
! 	if ((Ifile = fopen((char *)ztack(path,"/copy.in"), "w")) == NULL)
  		syserr(0,"Cannot create %s!",ztack(path,"/copy.in"));
! 	if ((Ofile = fopen((char *)ztack(path,"/copy.out"), "w")) == NULL)
  		syserr(0,"Cannot create %s!",ztack(path,"/copy.out"));
  
  
diff -r -c ../ingres.ptf/source/support/creatdb.c source/support/creatdb.c
*** ../ingres.ptf/source/support/creatdb.c	Mon Nov 16 14:39:00 1992
--- source/support/creatdb.c	Tue Sep 29 15:23:02 1992
***************
*** 1,4 ****
- 
  # include	<stdio.h>
  # include	<ingres.h>
  # include	<aux.h>
--- 1,3 ----
***************
*** 9,17 ****
--- 8,49 ----
  # include	<pv.h>
  # include	<sccs.h>
  # include	<sys/dir.h>
+ # include       <ctlmod.h>
  
  SCCSID(@(#)creatdb.c	8.7	10/7/86)
  
+ void rubproc();
+ int  readdbtemp();
+ int  getstat();
+ int  roctal();
+ int  getname();
+ int  makedb();
+ int  makeadmin();
+ int  makefile();
+ int  makereln();
+ int  check();
+ int  *flaglkup();
+ int  flagval();
+ int  changedb();
+ int  readadmin();
+ int  readdbtemp();
+ 
+ extern	char	*ztack();
+ extern  int     initucode();
+ extern  int     acc_init();
+ extern  int     getequal();
+ extern  int     bequal();
+ extern  int     sequal();
+ extern  int     closer();
+ extern  int     ingresname();
+ extern  int     create();
+ extern  int     opencatalog();
+ extern  int     clearkeys();
+ extern  int     setkey();
+ extern  int     checkadmin();
+ extern  int     replace();
+ 
+ 
  /*
  **  CREATDB -- create database (or modify database status)
  **
***************
*** 133,146 ****
  */
  
  
  
- 
  # define	MAXRELNS	20
  # define	MAXDBTEMP	2000
  
  /* relation & attribute reln descriptors used in access methods */
! extern DESC	Reldes;
! extern DESC	Attdes;
  
  extern int	Status;		/* user status, set by initucode */
  DESC		Btreesec;	/* desc for btree sec. structure */
--- 165,193 ----
  */
  
  
+ struct _cm_t	Cm;		/* the system topography map */
+ struct _ctx_t	Ctx;		/* the current context */
+ int		Syncs[CM_MAXPROC];/* expected SYNC's from each proc */
+ 
+ /* General System Information */
+   jmp_buf		CmReset;	/* restart addr on interrupt */
+ 
+ # ifdef xMONITOR
+  struct monitor	CmMonBuf;	/* monitor buffer for CM overhead */
+ # endif xMONITOR
  
  # define	MAXRELNS	20
  # define	MAXDBTEMP	2000
  
  /* relation & attribute reln descriptors used in access methods */
! /*  extern DESC	Reldes;        */
! DESC Reldes;
! /*  extern DESC	Attdes;        */
! DESC Attdes;
! /*   extern struct admin	Admin;      */
! extern int		errno;
! extern char		*Parmvect[];
! extern char		*Flagvect[];
  
  extern int	Status;		/* user status, set by initucode */
  DESC		Btreesec;	/* desc for btree sec. structure */
***************
*** 148,153 ****
--- 195,201 ----
  int		Btree_fd;	/* btree file */
  int		Dbstat;		/* database status */
  int		Dbson, Dbsoff;	/* same: bits turned on, bits turned off */
+ 
  typedef struct reldes
  {
  	int	bitson;
***************
*** 154,159 ****
--- 202,208 ----
  	int	bitsoff;
  	PARM	parmv[PV_MAXPC];
  } RELDES;
+ 
  RELDES	Rellist[MAXRELNS];
  char		Delim;
  extern char	*Dbpath;
***************
*** 160,166 ****
  short		tTdbu[100];
  
  
- 
  main(argc, argv)
  int	argc;
  char	*argv[];
--- 209,214 ----
***************
*** 168,175 ****
  	register int		i;
  	int			admin;
  	char			adminbuf[100];
- 	extern struct admin	Admin;
- 	extern int		errno;
  	auto int		code;
  	struct relation		relk;
  	char			*database;
--- 216,221 ----
***************
*** 179,197 ****
  	int			faterr;
  	register int		*flagv;
  	char			*dbtmpfile;
- 	extern char		*Parmvect[];
- 	extern char		*Flagvect[];
  	int			exists;
! 	int			*flaglkup();
! 	char			*ztack();
! 	extern char		*rindex();
! # ifdef	rewinddir
  	DIR			*dir_ptr;		/* pointer to '.' */
  	struct	direct		*dir;			/* directory entry */
- # else	rewinddir
- 	struct	dir		direct;
- # endif	rewinddir
- 
  	argv[argc] = NULL;
  
  #	ifdef xSTR1
--- 225,234 ----
  	int			faterr;
  	register int		*flagv;
  	char			*dbtmpfile;
  	int			exists;
! 
  	DIR			*dir_ptr;		/* pointer to '.' */
  	struct	direct		*dir;			/* directory entry */
  	argv[argc] = NULL;
  
  #	ifdef xSTR1
***************
*** 211,216 ****
--- 248,255 ----
  	switch (i)
  	{
  	  case 0:
+ 	        break;
+ 
  	  case 5:
  		exists = 1;
  		break;
***************
*** 313,323 ****
  #		endif
  		if (chdir(Dbpath) < 0)
  			syserr("chdir %s", Dbpath);
- 
  		if (!flagval('e'))
  		{
- # ifdef	rewinddir
- 
  			/* make certain that it is empty */
  			if ( (dir_ptr = opendir(".")) == NULL )
  				syserr(0,"Can't open '.'");
--- 352,359 ----
***************
*** 327,345 ****
  					syserr(0, "%s is not empty", database);
  			}
  			closedir(dir_ptr);
- 
- # else	rewinddir
- 			/* make certain that it is empty */
- 			freopen(".", "r", stdin);
- 			/* Skip "." and ".." entries */
- 			fread(&direct, sizeof (struct dir), 1, stdin);
- 			fread(&direct, sizeof (struct dir), 1, stdin);
- 			while ( fread(&direct, sizeof (struct dir), 1, stdin) != EOF)
- 			{
- 				if ( direct.d_ino != 0)
- 					syserr(0, "%s is not empty", database);
- 			}
- # endif	rewinddir
  		}
  		else
  		{
--- 363,368 ----
***************
*** 364,370 ****
  		if (i == 0)
  		{
  			/* split off directory */
! 			*(p = rindex(Dbpath, '/')) = '\0';
  			chdir(Dbpath);
  			if (setuid(getuid()))
  				syserr("setuid");
--- 387,393 ----
  		if (i == 0)
  		{
  			/* split off directory */
! 			*(p = (char *)rindex(Dbpath, '/')) = '\0';
  			chdir(Dbpath);
  			if (setuid(getuid()))
  				syserr("setuid");
***************
*** 465,471 ****
  /*
  **  Rubout processing.
  */
! 
  rubproc()
  {
  	exit(-2);
--- 488,494 ----
  /*
  **  Rubout processing.
  */
! void
  rubproc()
  {
  	exit(-2);
***************
*** 526,532 ****
  **	Trace Flags:
  **		none
  */
! 
  readdbtemp()
  {
  	static char	buf[MAXDBTEMP];
--- 549,555 ----
  **	Trace Flags:
  **		none
  */
! int
  readdbtemp()
  {
  	static char	buf[MAXDBTEMP];
***************
*** 666,672 ****
  **	Trace Flags:
  **		none
  */
! 
  getstat(def, bitson, bitsoff)
  int	def;
  int	*bitson;
--- 689,695 ----
  **	Trace Flags:
  **		none
  */
! int
  getstat(def, bitson, bitsoff)
  int	def;
  int	*bitson;
***************
*** 787,793 ****
  **	Trace Flags:
  **		none
  */
! 
  roctal()
  {
  	register int	c;
--- 810,816 ----
  **	Trace Flags:
  **		none
  */
! int
  roctal()
  {
  	register int	c;
***************
*** 839,845 ****
  **	Trace Flags:
  **		none
  */
! 
  getname(ptr)
  char	*ptr;
  {
--- 862,868 ----
  **	Trace Flags:
  **		none
  */
! int
  getname(ptr)
  char	*ptr;
  {
***************
*** 912,918 ****
  **	Trace Flags:
  **		20
  */
! 
  makedb()
  {
  	DESC		d;
--- 935,941 ----
  **	Trace Flags:
  **		20
  */
! int
  makedb()
  {
  	DESC		d;
***************
*** 975,983 ****
  **	Trace Flags:
  **		10
  */
! 
! 
! 
  makeadmin(d, pv)
  DESC	*d;
  PARM	pv[];
--- 998,1004 ----
  **	Trace Flags:
  **		10
  */
! int
  makeadmin(d, pv)
  DESC	*d;
  PARM	pv[];
***************
*** 1053,1060 ****
  **
  **	Trace Flags:
  **		12
! */
! 
  makefile(r)
  register RELDES	*r;
  {
--- 1074,1081 ----
  **
  **	Trace Flags:
  **		12
! v*/
! int
  makefile(r)
  register RELDES	*r;
  {
***************
*** 1098,1104 ****
  **	Trace Flags:
  **		1
  */
! 
  makereln(r)
  register RELDES	*r;
  {
--- 1119,1125 ----
  **	Trace Flags:
  **		1
  */
! int
  makereln(r)
  register RELDES	*r;
  {
***************
*** 1138,1144 ****
  **	Trace Flags:
  **		none
  */
! 
  check(p)
  char	*p;
  {
--- 1159,1165 ----
  **	Trace Flags:
  **		none
  */
! int
  check(p)
  char	*p;
  {
***************
*** 1278,1284 ****
  **	Trace Flags:
  **		none
  */
! 
  flagval(f)
  register char	f;
  {
--- 1299,1305 ----
  **	Trace Flags:
  **		none
  */
! int
  flagval(f)
  register char	f;
  {
***************
*** 1367,1373 ****
  **	Trace Flags:
  **		40
  */
! 
  changedb()
  {
  	register RELDES	*r;
--- 1388,1394 ----
  **	Trace Flags:
  **		40
  */
! int
  changedb()
  {
  	register RELDES	*r;
***************
*** 1474,1480 ****
  **	Trace Flags:
  **		none
  */
! 
  readadmin()
  {
  	register int	i;
--- 1495,1501 ----
  **	Trace Flags:
  **		none
  */
! int
  readadmin()
  {
  	register int	i;
Only in source/support: demo
diff -r -c ../ingres.ptf/source/support/destroydb.c source/support/destroydb.c
*** ../ingres.ptf/source/support/destroydb.c	Mon Nov 16 14:39:00 1992
--- source/support/destroydb.c	Tue Sep 29 15:04:54 1992
***************
*** 4,9 ****
--- 4,10 ----
  # include	<ingres.h>
  # include	<aux.h>
  # include	<access.h>
+ # include       <ctlmod.h>
  # include	<sccs.h>
  
  SCCSID(@(#)destroydb.c	8.3	1/31/86)
***************
*** 22,27 ****
--- 23,41 ----
  **	This is useful if the directory is a mounted file system.
  */
  
+ struct _cm_t	Cm;		/* the system topography map */
+ struct _ctx_t	Ctx;		/* the current context */
+ int		Syncs[CM_MAXPROC];/* expected SYNC's from each proc */
+ 
+ /* General System Information */
+ 
+ jmp_buf		CmReset;	/* restart addr on interrupt */
+ 
+ # ifdef xMONITOR
+ struct monitor	CmMonBuf;	/* monitor buffer for CM overhead */
+ # endif xMONITOR
+ 
+ 
  extern char	*Usercode;
  extern int	Status;
  extern char	*Pathname;
***************
*** 41,51 ****
  	char		**av;
  	register char	*p;
  	char		*q;
- # ifdef	rewinddir
  	DIR		*dirp;
- # else	rewinddir
- 	FILE		*iop;
- # endif	rewinddir
  
  	argv[argc] = NULL;
  #	ifdef xSTR1
--- 55,61 ----
***************
*** 141,158 ****
  	if (chdir(Dbpath) < 0)
  		syserr("chdir %s", Dbpath);
  
- # ifdef	rewinddir
  	if ( (dirp = opendir(".")) == NULL )
  		syserr("Can't open . in %s",Dbpath);
  	clean(dirp);
  	closedir(dirp);
- # else	rewinddir
- 	iop = fopen(".", "r");
- 	if (iop == NULL)
- 		syserr("Cannot open dot in %s", Dbpath);
- 	clean(iop);
- 	fclose(iop);
- # endif	rewinddir
  
  	if (!mounted)
  	{
--- 151,160 ----
***************
*** 172,179 ****
  }
  
  
! 
! # ifdef	rewinddir
  clean(dirp)
  register DIR	*dirp;
  {
--- 174,180 ----
  }
  
  
! int
  clean(dirp)
  register DIR	*dirp;
  {
***************
*** 196,247 ****
  	}
  }/* clean */
  		
- # else	rewinddir
- 
- clean(f)
- register FILE	*f;
- {
- 	struct direc
- 	{
- 		struct direct	d;
- 		char		null;
- 	};
- 	struct direc	cur;
- 
- #	ifdef xSTR1
- 	if (tTf(2, 0))
- 		printf("clean: ");
- #	endif
  
- 	cur.null = 0;
- 
- 	/* skip "." and ".." entries */
- 	fread(&cur, sizeof cur.d, 1, f);
- 	fread(&cur, sizeof cur.d, 1, f);
- 
- 	/* scan directory */
- 	while (fread(&cur, sizeof cur.d, 1, f) > 0)
- 	{
- 		/* skip null entries */
- 		if (cur.d.d_ino == 0)
- 			continue;
- 
- #		ifdef xSTR1
- 		if (tTf(2, 1))
- 			printf("unlinking %s\n", cur.d.d_name);
- #		endif
- 		unlink(cur.d.d_name);
- 	}
- }
- # endif	rewinddir
- 
- 
- 
  /*
  **  Rubout processing.
  */
  
  rubproc()
  {
  	exit(-2);
  }
--- 197,210 ----
  	}
  }/* clean */
  		
  
  /*
  **  Rubout processing.
  */
  
+ void
  rubproc()
  {
  	exit(-2);
  }
+ 
diff -r -c ../ingres.ptf/source/support/externs.c source/support/externs.c
*** ../ingres.ptf/source/support/externs.c	Mon Nov 16 14:39:00 1992
--- source/support/externs.c	Fri Jun  5 10:59:45 1992
***************
*** 9,14 ****
--- 9,15 ----
  	return ((map[n/BITS] & (1<<(n%BITS))) != 0);
  }
  char	Qbuf[1000];
+ int     QbufSize = sizeof Qbuf;
  
  extern struct fn_def	CopyFn;
  extern struct fn_def	CreateFn;
diff -r -c ../ingres.ptf/source/support/helpr.c source/support/helpr.c
*** ../ingres.ptf/source/support/helpr.c	Mon Nov 16 14:39:01 1992
--- source/support/helpr.c	Tue Sep 29 15:05:14 1992
***************
*** 4,14 ****
--- 4,27 ----
  # include	<access.h>
  # include	<lock.h>
  # include	<pv.h>
+ # include       <ctlmod.h>
  # include	<sccs.h>
  
  SCCSID(@(#)helpr.c	8.2	2/8/85)
  
+ struct _cm_t	Cm;		/* the system topography map */
+ struct _ctx_t	Ctx;		/* the current context */
+ int		Syncs[CM_MAXPROC];/* expected SYNC's from each proc */
+ 
+ /* General System Information */
+ jmp_buf		CmReset;	/* restart addr on interrupt */
+ 
+ # ifdef xMONITOR
+ struct monitor	CmMonBuf;	/* monitor buffer for CM overhead */
+ # endif xMONITOR
  
+ 
+ 
  extern int	Status;
  short		tTdbu[100];
  DESC		Btreesec;
***************
*** 198,205 ****
  		return (NULL);
  }
  
! 
  rubproc()
  {
  	exit(1);
  }
--- 211,219 ----
  		return (NULL);
  }
  
! void
  rubproc()
  {
  	exit(1);
  }
+ 
diff -r -c ../ingres.ptf/source/support/ildr.c source/support/ildr.c
*** ../ingres.ptf/source/support/ildr.c	Mon Nov 16 14:39:01 1992
--- source/support/ildr.c	Fri Sep 25 18:39:55 1992
***************
*** 29,34 ****
--- 29,51 ----
  
  SCCSID(@(#)ildr.c	8.2	6/12/88)
  
+ extern  int     init_sokeet();
+ int             new_proc();
+ int             ilwrite();
+ int             ilrma();
+ int             set_lock();
+ int             send_info();
+ int             wait_on();
+ int             wakeup();
+ int             close_up();
+ void            abnormal();
+ static  int     ilunique();
+ static  int     ilfind();
+ static  int     ilrm();
+ static  int     ilenter();
+ static  int     ilcomp();
+ static  int     ilclose();
+ 
  int	From_server;		/* read connection from socket server */
  long	Read_fmt;		/* bit mask for select */
  char	*Prog_name;		/* program name for abnormal errors */
***************
*** 45,53 ****
  {
  	long		read_fd,		/* bit mask of useable descriptors*/
  			num_des;		/* number of readable descriptors */
! 	int		abnormal();		/* error function */
  	register	int	i;		/* index */
! 
  
  	/*
  	** close all the files descriptors, so we can have more INGRES
--- 62,70 ----
  {
  	long		read_fd,		/* bit mask of useable descriptors*/
  			num_des;		/* number of readable descriptors */
! 	void		abnormal();		/* error function */
  	register	int	i;		/* index */
!         struct timeval        tv;               /* added by K.Okamoto  */
  
  	/*
  	** close all the files descriptors, so we can have more INGRES
***************
*** 67,75 ****
  	** is an error. We do a "warm start" in this condition
  	*/
  	for ( i = 0 ; i < NSIG ; i++ )
! 		signal(i,abnormal);
! 	signal(SIGPIPE,SIG_IGN);	/* ignore this one, in case a process simply dies in mid stride */
! 	Prog_name = *av;
  	/*
  	** if ac == 2, then we are restarted from the the lock driver
  	** itself, and we don't have to reattach ourselves to the magic
--- 84,92 ----
  	** is an error. We do a "warm start" in this condition
  	*/
  	for ( i = 0 ; i < NSIG ; i++ )
! 		signal(i, abnormal);
!        	signal(SIGPIPE,SIG_IGN);	/* ignore this one, in case a process simply dies in mid stride */
!         Prog_name = *av;
  	/*
  	** if ac == 2, then we are restarted from the the lock driver
  	** itself, and we don't have to reattach ourselves to the magic
***************
*** 83,88 ****
--- 100,107 ----
  		From_server = init_socket();
  	}
  	Read_fmt = (1<<From_server);
+         tv.tv_sec = 0;
+         tv.tv_usec = 0; 
  
  	/*
  	** infinite loop waiting for something to happen
***************
*** 94,100 ****
--- 113,125 ----
  		/*
  		** wake up whenever something happens
  		*/
+ 
+ 		num_des = select(NOFILE,&read_fd,0,0,0);
+ 
  		while ( (num_des = select(NOFILE,&read_fd,0,0,0)) == 0 )
+ /*
+ 		while ( (num_des = select(NOFILE,&read_fd,NULL,NULL,&tv)) == 0 )
+ */
  		{
  # ifdef	DEBUG
  		printf("select returns 0 (%o)\n",read_fd);
***************
*** 104,109 ****
--- 129,136 ----
  # ifdef	DEBUG
  		printf("select returns %d (%o)\n",num_des,read_fd);
  # endif	DEBUG
+ 
+ 
  		if ( num_des == -1 )
  		{
  # ifdef	DEBUG
***************
*** 113,119 ****
  			** a bit of defensive programming.
  			** If there is an EBADF (bad file descriptor) error 
  			** then we assume that a file descriptor has shut down,
! 			** with out tellng us. We go to a function to figure
  			** out what has died.
  			*/
  			if ( errno == EBADF )
--- 140,146 ----
  			** a bit of defensive programming.
  			** If there is an EBADF (bad file descriptor) error 
  			** then we assume that a file descriptor has shut down,
! 			** without tellng us. We go to a function to figure
  			** out what has died.
  			*/
  			if ( errno == EBADF )
***************
*** 140,145 ****
--- 167,173 ----
  ** new_proc
  ** start up a new connection to an Ingres process
  */
+ int
  new_proc()
  {
  	register	int	fd;
***************
*** 148,157 ****
  	auto		int	len;
  
  	len = sizeof (addr);
! 	if ( (fd = accept(From_server,&addr,&len)) != -1 )
  	{
  		Read_fmt |= (1<<fd);
! 		ioctl(fd,FIONBIO,&to_ioctl);
  	}
  # ifdef	DEBUG
  	else
--- 176,185 ----
  	auto		int	len;
  
  	len = sizeof (addr);
! 	if ( (fd = accept(From_server,(struct sockaddr *)&addr,&len)) != -1 )
  	{
  		Read_fmt |= (1<<fd);
! 		ioctl(fd,FIONBIO,&to_ioctl);   /* set sockets to nonblocking */
  	}
  # ifdef	DEBUG
  	else
***************
*** 164,170 ****
  }/* new_proc */
  
  
! 
  ilwrite(read_desc)
  register	int	read_desc;
  {
--- 192,198 ----
  }/* new_proc */
  
  
! int
  ilwrite(read_desc)
  register	int	read_desc;
  {
***************
*** 308,313 ****
--- 336,342 ----
  	}
  	send_info(read_desc,0);
  }
+ 
  /*
   *	ilunique- check for match on key
   *	
***************
*** 314,320 ****
   *	return index of Locktab if match found
   *	else return -1
   */
! static
  ilunique(ll)
  register struct Lockreq *ll;
  {
--- 343,350 ----
   *	return index of Locktab if match found
   *	else return -1
   */
! 
! static int
  ilunique(ll)
  register struct Lockreq *ll;
  {
***************
*** 345,351 ****
  	return(-1);
  }
  
! static
  ilfind(ll,key)
  register struct Lockreq *ll;
  int	key;
--- 375,381 ----
  	return(-1);
  }
  
! static int
  ilfind(ll,key)
  register struct Lockreq *ll;
  int	key;
***************
*** 370,376 ****
   *	remove the lth Lock
   *		if the correct user is requesting the move.
   */
! static
  ilrm(l,key,remove_all)
  int l;
  int	key;
--- 400,407 ----
   *	remove the lth Lock
   *		if the correct user is requesting the move.
   */
! 
! static int
  ilrm(l,key,remove_all)
  int l;
  int	key;
***************
*** 405,410 ****
--- 436,442 ----
   *	ilrma releases all locks for a given process id(pd)
   *	-- called from sys1.c$exit() code.
   */
+ int
  ilrma(key,remove_all)
  int key;
  int	remove_all;
***************
*** 423,429 ****
   *	return position in Locktable
   *	error return of -1
   */
! static
  ilenter(ll,key)
  register struct Lockreq *ll;
  int key;
--- 455,462 ----
   *	return position in Locktable
   *	error return of -1
   */
! 
! static int
  ilenter(ll,key)
  register struct Lockreq *ll;
  int key;
***************
*** 465,471 ****
   *	  	returns 0 if strings match
   *		returns -1 otherwise
   */
! static
  ilcomp(s1,s2)
  register char *s1,*s2;
  {
--- 498,505 ----
   *	  	returns 0 if strings match
   *		returns -1 otherwise
   */
! 
! static int
  ilcomp(s1,s2)
  register char *s1,*s2;
  {
***************
*** 488,494 ****
  /*
   *	ilclose- releases all locks
   */
! static
  ilclose()
  {
  	register int	k;
--- 522,529 ----
  /*
   *	ilclose- releases all locks
   */
! 
! static int
  ilclose()
  {
  	register int	k;
***************
*** 514,519 ****
--- 549,556 ----
  ** attempt to set a lock. If we can't, block the process and
  ** return -1, if we can than set the lock and return 0.
  */
+ 
+ int
  set_lock(read_desc,lockbuf)
  register	int	read_desc;
  struct	Lockreq	lockbuf;
***************
*** 560,565 ****
--- 597,604 ----
  ** Send the data down the socket. Don't do it if it would cause the driver
  ** to block.
  */
+ 
+ int
  send_info(fd,data)
  register	int	fd;
  int	data;
***************
*** 571,577 ****
  	time.tv_sec = 10;
  	time.tv_usec = 0;
  
! 	if ( select(NOFILE,0,&wdes,0,&time) != 1 )
  	{
  		Read_fmt &= ~(1<<fd);
  		ilrma(fd,TRUE);
--- 610,616 ----
  	time.tv_sec = 10;
  	time.tv_usec = 0;
  
! 	if ( select(NOFILE,NULL,&wdes,NULL,&time) != 1 )
  	{
  		Read_fmt &= ~(1<<fd);
  		ilrma(fd,TRUE);
***************
*** 600,605 ****
--- 639,646 ----
  ** wait_on
  ** Set up to wait for a free lock.
  */
+ 
+ int
  wait_on(fd,lock,req)
  register	int	fd, lock;
  struct		Lockreq	req;
***************
*** 620,625 ****
--- 661,668 ----
  ** See if there is anythng waiting on the newly freed lock. If there is,
  ** tell it it can have the lock now.
  */
+ 
+ int
  wakeup(lock)
  register	int	lock;
  {
***************
*** 648,653 ****
--- 691,698 ----
  ** a signal has come down and hit us. We restart the entire
  ** program, and hope it goes away
  */
+ 
+ void
  abnormal(sig)
  int	sig;
  {
***************
*** 654,665 ****
  	extern	int	errno;
  
  # ifdef	DEBUG
! 	printf("DRIVER: error %d, restarting\n",sig);
  # endif
  
! 	execl("/etc/lock_driver","lock_driver","restart",0);
  	execl(Prog_name,Prog_name,"restart",0);
! 	execlp("lock_driver","lock_driver","restart",0);
  	exit(4);
  }/* abnormal */
  
--- 699,711 ----
  	extern	int	errno;
  
  # ifdef	DEBUG
! 	printf("DRIVER: error Signal No. = %d, restarting\n",sig);
  # endif
  
! /*	execl("/etc/lock_driver","lock_driver","restart",0);   */
! 	execl("/etc/ingreslock","lock_driver","restart",0);
  	execl(Prog_name,Prog_name,"restart",0);
! 	execlp("ingreslock","lock_driver","restart",0);
  	exit(4);
  }/* abnormal */
  
***************
*** 667,672 ****
--- 713,720 ----
  ** close_up
  ** try and find a closed up file descriptor.
  */
+ 
+ int
  close_up(fmt)
  long	fmt;
  {
